#include <stdio.h>
#include <math.h>

double poolpikkus(double[]);
double nurk(double[], int);
void minutid(double, double*, double*);

int main(void){
  int kokku=3;
  double kyljed[kokku];
  int nr, alg, pikk;
  double p, skorrutis, pindala, kraad, minut, sekund;
  double pisike=1e-5;
  do{
    for(nr=0; nr<kokku; nr++){
     do{
      printf("Palun kylg nr %d ", nr); scanf("%lf", &kyljed[nr]);   
      if(kyljed[nr]<=0+pisike) printf("Kyljepikkus peab olema positiivne\n");
     }while(kyljed[nr]<=0);
    }
    pikk=0;
    for(alg=0; alg<kokku; alg++){
      if(kyljed[alg%3]+pisike>=kyljed[(alg+1)%3]+kyljed[(alg+2)%3])pikk=1;
    }
    if(pikk)printf("Pikim ku\"lg u\"letab teiste summa\n");
   }while(pikk);
   p=poolpikkus(kyljed);
   skorrutis=p;
   for(nr=0; nr<kokku; nr++){
     skorrutis*=(p-kyljed[nr]);
   }
   pindala=sqrt(skorrutis);
   
   printf("Pindala=%6.3f\n", pindala);
   for(nr=0; nr<kokku; nr++){
     kraad=nurk(kyljed, nr);
     minutid(kraad, &minut, &sekund);
     printf("Nurk %d on suurusega %5.2f kraadi, %d minutit, %d sekundit\n", 
       nr, nurk(kyljed, nr), (int)minut, (int)sekund);
   }
   return 0;
}

double poolpikkus(double andmed[]){
 double summa=0;
 int i;
 for(i=0; i<3; i++){
   summa+=andmed[i];
 }
 return summa/2.0;
}

double nurk(double andmed[], int nr){
  double suhe, rd, kraad;
  double a=andmed[(nr%3)];
  double b=andmed[((nr+1)%3)];
  double c=andmed[((nr+2)%3)];
  suhe=(a*a-b*b-c*c)/(double)(-2*b*c);
  rd=acos(suhe);
  kraad=rd*180/3.14;
  return kraad; 
}

void minutid(double kraad, double* minut, double* sekund){
  int taiskraad=kraad;
  *minut=((kraad-taiskraad)*60);
  *sekund=((*minut-(int) (*minut))*60);
}