import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class Tripsuklient extends Applet{
  static String serverinimi=Tripsuserver.masin;
  public void init(){
    serverinimi=getCodeBase().getHost();
    setLayout(new BorderLayout());
    add("Center", new Tripsupaneel());
  }

  public static void main(String argumendid[]){
    if(argumendid.length>0)serverinimi=argumendid[0];
    Frame f=new Frame("Tripsuraam");
    f.add("Center", new Tripsupaneel());
    f.setSize(300, 300);
    f.setVisible(true);
  }
}



class Tripsupaneel extends Panel{
  Button nupp[]=new Button[10];
  String omanimi;
  TextArea suhtlus=new TextArea("",3, 60,TextArea.SCROLLBARS_VERTICAL_ONLY);
  public Tripsupaneel(){
    setLayout(new BorderLayout());
    add("North", suhtlus);
    Panel nupupaneel=new Panel();
    nupupaneel.setLayout(new GridLayout(3, 3));
    for(int i=0; i<9; i++){
      nupp[i]=new Button("  ");
      nupupaneel.add(nupp[i]);
    }
    add("Center", nupupaneel);
    nupp[9]=new Button("Stopp");
    add("South", nupp[9]);
    seaNupud(false);
    TripsukliendiLoim vahendaja=new TripsukliendiLoim(this);
  }

  void seaNupud(boolean kasutatav){
    if(!kasutatav)for(int i=0; i<nupp.length; i++)nupp[i].setEnabled(kasutatav);
    else{
      for(int i=0; i<9; i++)if(nupp[i].getLabel().trim().equals(""))
         nupp[i].setEnabled(kasutatav);
    }
    nupp[9].setEnabled(kasutatav);
  }
}

class TripsukliendiLoim implements ActionListener, Runnable{
  Tripsupaneel tp;
  PrintWriter valja;
  BufferedReader sisse;
  boolean veel=true;
  Socket sc;

  public TripsukliendiLoim(Tripsupaneel utp){
    tp=utp;
    for(int i=0; i<10; i++)tp.nupp[i].addActionListener(this);
    alusta();
  }

  public boolean alusta(){
    boolean korras=true;
    try{
     for(int i=0; i<9; i++)tp.nupp[i].setLabel(" ");
     tp.nupp[9].setLabel("Stopp");
     tp.suhtlus.setText("");
     sc=new Socket(Tripsuklient.serverinimi, Tripsuserver.pordinr);
     sisse=new BufferedReader(
        new InputStreamReader(sc.getInputStream())
     );
     valja=new PrintWriter(sc.getOutputStream(), true);
     veel=true;
     new Thread(this).start();
    }catch(IOException e){
      e.printStackTrace();
      tp.suhtlus.setText("hendus serveriga "+Tripsuklient.serverinimi+" puudub.");
      korras=false;
    }
    return korras;
  }

  public void run(){
    System.out.println("Loime algus");
    try{
       while(veel){
         System.out.println("veel="+veel);
         tootle(sisse.readLine());
       }
    } catch (Exception e){
      System.out.println("Probleem: "+e);
      e.printStackTrace();
    }
    System.out.println("Loime ots");
  }

  private void tootle(String teade) throws IOException{
    tp.suhtlus.setText(tp.suhtlus.getText()+teade+"\n");
    if(teade.startsWith(".margiks"))tp.omanimi=teade.substring(8, 9);
    if(teade.startsWith(".kaik")){
      try{
        int nr=Integer.parseInt(teade.substring(6, 7));
        tp.nupp[nr].setLabel(
          " "+teade.substring(5, 6)+" "
        );
      } catch(NumberFormatException e){} //sobimatu ruut
      if(!teade.substring(5, 6).equals(tp.omanimi))tp.seaNupud(true);
    }
    if(teade.equals(Tripsuserver.lopp)){
      veel=false;
      tp.nupp[9].setLabel("Start");
      tp.nupp[9].setEnabled(true);
      sc.close();
    }
  }

  public void actionPerformed(ActionEvent e){
    System.out.println("Vajutus");
    tp.seaNupud(false);    
    int nr=0;
    Button allikas=(Button)e.getSource();
    for(int i=0; i<10; i++)if(tp.nupp[i]==allikas)nr=i;
    if(nr<9)
      valja.println(".kaik"+tp.omanimi+nr);
    else if(nr==9){
      if(tp.nupp[9].getLabel().equals("Stopp"))
         valja.println(".ots");
      else {
        tp.nupp[9].setLabel("Stopp");
        alusta();
      }
    }
  }
}
